//===========================================================================
//		• DownloadProgressController						Tomato
//===========================================================================
//	© 2005 Sarwat Khan

#import <Cocoa/Cocoa.h>

@interface DownloadProgressController : NSWindowController
{
	id			_timer;
	SEL			_timerMethod;
	SEL			_slowTimer;
	
	id			_configTimer;
	int			_configWaitNum;
	
	id			_progressTickleTimer;
	
	id			_torrentProgressView;
	id			_mainTabView;
	id			_detailsTabView;

    IBOutlet id _progressBar;
	BOOL		_showingProgress;
	BOOL		_animatingProgress;
	
    IBOutlet id _fileNameField;
    IBOutlet id _downloadRateField;
    IBOutlet id _timeLeftField;
    IBOutlet id _uploadRateField;
    IBOutlet id _lastErrorField;

    IBOutlet id _errorText;
    IBOutlet id _statsTable;
    IBOutlet id _statsFreezeButton;

	NSBox*		_detailsBox;
	id			_detailsView;
	
	id			_saveEmptyView;
	
	BOOL		_isTrackingProgress;
	BOOL		_isFinished;
	
	double		_lastPercentDone;
	id			_lastResponse;
	unsigned	_lastErrorCount;
	id			_lastActivity;
	BOOL		_freezeStatsTable;
	id			__lastTorrentConnectionRate;
	
	id			_errorFormatter;
	
	NSSize		_smallContentSize;
	NSSize		_expandedContentSize;
	
	id			_rateText;
	id			_activityText;
	
	id			__savedStats;
	
	id			__maxFilesConfigProgress;
	id			__maxFilesEditText;
	id			__uprateConfigProgress;
	id			__uprateEditText;
	
	BOOL		__validForAutostop;
	id			__seedingStartDate;
}
- trackTorrentDownloadProgress;
- stopTrackingTorrentProgress;

- torrentDownloadDidStartup:response;
- failedResponse:response answeredTo:(SEL)selector;

- currentActivityName;
- lastResponseContent;	//was 'statistics'

- (void) reloadData;

- (IBAction)toggleDetails:(id)sender;
- (void) freezeStatsTable:sender;

- (void) stopTorrentIfNowIsAGoodTimeToDoThat;
@end
