//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khan’s name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/* GenerateTorrentsController */

#import <Cocoa/Cocoa.h>

@interface GenerateTorrentsController : NSWindowController
{
    IBOutlet id _cancelButton;
    IBOutlet id _currentFileText;
    IBOutlet id _emptyView;
    IBOutlet id _generateButton;
    IBOutlet id _generationView;
    IBOutlet id _pieceSizeText;
    IBOutlet id _progressBar;
	IBOutlet id _removeButton;
    IBOutlet id _tableView;
    IBOutlet id _urlText;
	
	id			_files;
	id			_attribs;
	id			_setupView;
	
	id			__trackerHistory;
	
	int			_state;
	
	id			_agent;
	id			_timer;
	id			_lastResponse;
	
	id			_faultTitle;
	id			_faultDisplay;
	
	id			_nextTaskTabView;
	id			_progressTabView;
	
	id			_numItemsDisplay;
	id			_bytesProcessedDisplay;
	
	id	__destinationFolderText;
	id	__trackerTypeTabView;
	id	__trackerlessTypeTabView;
	id	__trackerlessTypeRadioMatrix;
	id	__trackerlessNodesText;
}

+ instance;

- (void) showGenerationSetup:sender;

- (void) reloadData;
- (BOOL) isReadyToGenerateTorrents;
@end
