//==============================================================================
//		• GenerateTorrentsController.m
//==============================================================================
//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khan’s name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

//		this file is a big wonky mess. this is because I don't care. I just want it functional. this file does not undergo spring cleaning.

#import "GenerateTorrentsController.h"

#import "TomatoTorrentAgent.h"
#import "TorrentFaultFormatter.h"
#import "NSWindow+WindowContentSize.h"
#import "NSFileManager+LocalizedPaths.h"

#define kUserDefault_generateTorrents_trackerHistory		@"generateTorrentsTrackerURLs"
#define kUserDefault_generateTorrents_lastSourceFolder		@"generateTorrentsLastSourceFolder"
#define kUserDefault_generateTorrents_lastTargetFolder		@"generateTorrentsLastTargetFolder"

#define kUserDefault_generateTorrents_trackerType			@"generateTorrentsTrackerType"
#define kUserDefault_generateTorrents_trackerlessType		@"generateTorrentsTrackerlessType"
#define kUserDefault_generateTorrents_trackerlessNodes		@"generateTorrentsTrackerlessNodesString"

#define kUserDefault_generateTorrents_isTrackerless			@"generateTorrentsIsTrackerless"
#define kUserDefault_generateTorrents_useTrackerlessAuto	@"generateTorrentsUseTrackerlessAuto"

#define kTabIdentifier_nextTaskDescription					@"open panel title is stupid"
#define kTabIdentifier_empty								@"empty"
#define	kTabIdentifier_fault								@"fault"
#define kTabIdentifier_progress								@"progress"

#define kTabIdentifier_tracker								@"tracker"
#define kTabIdentifier_trackerless							@"trackerless"

	//currently defined in DownloadProgressController.m
id	bt_format_file_size_object(id object);

enum {
	kGenerateTorrentsState_setup = 0,
	kGenerateTorrentsState_generating,
	kGenerateTorrentsState_done,
	kGenerateTorrentsState_fault
};

enum {
	kTrackerlessSpecificNodesTag = 0,
	kTrackerlessAutoNodesTag
};

#define kLastTrackerURL @"LastTrackerForGeneratedTorrents"

static id	g_instance = nil;

static Class g_nsTokenField = nil;


@interface NSObject (NSTokenField)
- (void)setTokenizingCharacterSet:(NSCharacterSet *)characterSet;
- (void)setTokenStyle: (int)style;
@end

@interface GenerateTorrentsController (Private)
- _announceURL;
- (int) _pieceSize;
- _filePaths;

- _agent;
- _updateGenerateButton;

- _startTrackingAgent;					//sets state to generating
- _stopTrackingAgent:(int)state;		//sets state to given
- _setState:(int)state;					//installs and reloads views for given state

- _updateGenerateStats;
- _showCompletionStats;
- _showFaultResponse;

- _displayResponseFault;				//the user shouldn't see these... but I'm lazy so they might.
- _setLastResponse:response;
@end

@implementation GenerateTorrentsController

+ (void) initialize
{
	[[NSUserDefaults standardUserDefaults] registerDefaults:
		[NSDictionary dictionaryWithObjectsAndKeys:
			[NSArray array],		kUserDefault_generateTorrents_trackerHistory,
			NSHomeDirectory(),		kUserDefault_generateTorrents_lastSourceFolder,
			NSHomeDirectory(),		kUserDefault_generateTorrents_lastTargetFolder, 
			[NSNumber numberWithBool:NO],	kUserDefault_generateTorrents_isTrackerless,
			[NSNumber numberWithBool:YES],	kUserDefault_generateTorrents_useTrackerlessAuto,
			@"router.bittorrent.com:6881",	kUserDefault_generateTorrents_trackerlessNodes,
			nil]];
}

+ instance
{
	if (g_instance == nil) 
		g_instance = [self new];
	
	return g_instance;
}

- init
{
	__trackerHistory = [[NSUserDefaults standardUserDefaults] 
		objectForKey:kUserDefault_generateTorrents_trackerHistory];
	if ([__trackerHistory isKindOfClass:[NSArray class]] == NO)
		__trackerHistory = [NSMutableArray new];
	else
		__trackerHistory = [[NSMutableArray alloc] initWithArray:__trackerHistory];

	_files = [NSMutableArray new];
	_attribs = [NSMutableArray new];
	_state = kGenerateTorrentsState_setup;

	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(_appWillTerminate:)
												 name:NSApplicationWillTerminateNotification
											   object:nil];		
	
	return [super initWithWindowNibName:@"GenerateTorrents"];
}

- (void) dealloc
{
	if (_agent)
	{
		[_agent shutdown];
		[_agent release];
	}
	[_timer invalidate];
	_timer = nil;
	
	[[NSNotificationCenter defaultCenter] removeObserver:self];
	
	[__trackerHistory release];
	
	if (g_instance == self)
		g_instance = nil;
	
	[super dealloc];
}

- (void) windowDidLoad
{
	id		destFolder, defaults;

	defaults = [NSUserDefaults standardUserDefaults];
	
	_setupView = [[[self window] contentView] retain];
	[[self window] center];
	
	[_progressBar setControlSize:NSProgressIndicatorPreferredAquaThickness];

	[_tableView sizeLastColumnToFit];
	[_tableView registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];

	//destination folder text
	destFolder = [defaults 
					stringForKey:kUserDefault_generateTorrents_lastTargetFolder];
	if (destFolder == nil) destFolder = NSHomeDirectory();
	[__destinationFolderText setStringValue:[[NSFileManager defaultManager] displayPathForPath:destFolder]];	

	//restore the tab views & radio buttons
	[__trackerTypeTabView selectTabViewItemWithIdentifier:
		([defaults boolForKey:kUserDefault_generateTorrents_isTrackerless]
		 ? kTabIdentifier_trackerless : kTabIdentifier_tracker)];

	int		thingTag = ([defaults boolForKey:kUserDefault_generateTorrents_useTrackerlessAuto]
						? kTrackerlessAutoNodesTag : kTrackerlessSpecificNodesTag);
	
	[__trackerlessTypeTabView selectTabViewItemAtIndex:thingTag];
	[__trackerlessTypeRadioMatrix selectCellWithTag:thingTag];
	
	//see if we have a token field cell,
	{
		NSRect		fieldFrame;
		id			superview, font;
		
		if ((g_nsTokenField = NSClassFromString(@"NSTokenField")))
		{
			superview = [__trackerlessNodesText superview];
			fieldFrame = [__trackerlessNodesText frame];
			font = [__trackerlessNodesText font];
			[__trackerlessNodesText removeFromSuperview];
			
			__trackerlessNodesText = [[g_nsTokenField alloc] initWithFrame:fieldFrame];
			[[__trackerlessNodesText cell] setControlSize:NSSmallControlSize];
			[__trackerlessNodesText setFont:font];
			[superview addSubview:__trackerlessNodesText];
			
			[__trackerlessNodesText setTokenizingCharacterSet:[NSCharacterSet characterSetWithCharactersInString:@", "]];
			[__trackerlessNodesText setTokenStyle:2];	//NSRoundedTokenStyle
			[__trackerlessNodesText setDelegate:self];
			
			[__trackerlessNodesText setObjectValue:
				[[defaults stringForKey:kUserDefault_generateTorrents_trackerlessNodes] componentsSeparatedByString:@","]];
		}
		else
			[__trackerlessNodesText setObjectValue:[defaults stringForKey:kUserDefault_generateTorrents_trackerlessNodes]];
	}
	

	_state = kGenerateTorrentsState_setup;
}

- (NSArray *)tokenField:tokenField shouldAddObjects:(NSArray *)tokens atIndex:(unsigned)index;
{
	id		result = [NSMutableArray array];
	id		ite, obj;
	
	ite = [tokens objectEnumerator];
	while ((obj = [ite nextObject]))
	{
		if (![obj isEqual:@" "])
		{
			if ([obj rangeOfString:@":"].location != NSNotFound)
				[result addObject:obj];
		}
	}
	
	return result;
}

- (void) showGenerationSetup:sender
{
	if (_state != kGenerateTorrentsState_generating)
	{
		[self _setState:kGenerateTorrentsState_setup];
	}
	
	[[self window] makeKeyAndOrderFront:nil];
}

- (IBAction)addItems:(id)sender
{
	id		openPanel, directory;
	
	[[self window] endEditingFor:nil];
	
	openPanel = [NSOpenPanel openPanel];
	
	[openPanel setCanChooseDirectories:YES];
	[openPanel setAllowsMultipleSelection:YES];
	
	directory = [[NSUserDefaults standardUserDefaults] 
					stringForKey:kUserDefault_generateTorrents_lastSourceFolder];

	[openPanel beginSheetForDirectory:directory 
								 file:nil
								types:nil
					   modalForWindow:[self window]
					    modalDelegate:self 
					   didEndSelector:@selector(_userChoseSourceItemsFrom:returnCode:contextInfo:) 
						  contextInfo:nil];
}

- (IBAction)cancelGeneration:(id)sender
{
	if ([[self _agent] stopGenerate:self] == nil)
		[_cancelButton setStringValue:SKLocalizedString(@"Click Again!", @"couldn't cancel button title")];
			//this shouldn't happen... I think. I should probably allow the user to kill the process after
			//a certain amount of time.
}

- (IBAction)removeSelectedItems:(id)sender
{
	unsigned		numSelected;
	
	[[self window] endEditingFor:nil];
	
	numSelected = [_tableView numberOfSelectedRows];

	if (numSelected > 0)
	{
		id			ite = [_tableView selectedRowEnumerator];
		id			object;
		unsigned	*indices;
		int			index = 0;
		
		indices = malloc(sizeof(unsigned) * numSelected);
		
		while (object = [ite nextObject])
			*(indices + index++) = [object unsignedIntValue];
			
		[_files removeObjectsFromIndices:indices numIndices:numSelected];
		[_attribs removeObjectsFromIndices:indices numIndices:numSelected];
			
		free(indices);
		
		[_tableView reloadData];
	}
}

- (void) chooseDestinationFolderAction:sender
{
	id		openPanel =  [NSOpenPanel openPanel];
	id		directory;

	[openPanel setCanChooseDirectories:YES];
	[openPanel setCanChooseFiles:NO];

	[openPanel setTitle:SKLocalizedString(
										  @"Choose a Folder To Save the Generated Torrents", 
										  @"torrent generation choose target directory title")];
	[openPanel setPrompt:SKLocalizedString(
										   @"Choose", 
										   @"torrent generation choose target directory prompt")];

	directory = [[NSUserDefaults standardUserDefaults] 
						stringForKey:kUserDefault_generateTorrents_lastTargetFolder];

	[openPanel beginSheetForDirectory:directory
								 file:nil
								types:nil
					   modalForWindow:[self window]
					    modalDelegate:self 
					   didEndSelector:@selector(__userChoseTargetDirectory:returnCode:contextInfo:) 
						  contextInfo:nil];
}

- (void) trackerlessTypeRadioAction:sender
{
	//switch the tab view to the right thing.
	[__trackerlessTypeTabView selectTabViewItemAtIndex:[[sender selectedCell] tag]];	//**crosses fingers**
	[self _updateGenerateButton];
}

- (BOOL) generatesTrackerlessTorrents;
{
	return [[[__trackerTypeTabView selectedTabViewItem] identifier] isEqual:kTabIdentifier_trackerless];
}

- (BOOL) trackerlessTorrentsUseSpecificNodes
{
	return [[__trackerlessTypeRadioMatrix selectedCell] tag] == kTrackerlessSpecificNodesTag;
}

- (NSString*) DHTNodesAsString;
{
	id	result = @"";
	
	if (g_nsTokenField)
	{
		result = [(id)[__trackerlessNodesText objectValue] componentsJoinedByString:@","];
	}
	else
	{
		result = [__trackerlessNodesText stringValue];
	}
	
	return result;
}

- (BOOL) isReadyToGenerateTorrents
{
	BOOL	result = NO;
	id		savePath;
	BOOL	isDir = NO;
	
	savePath = [[NSUserDefaults standardUserDefaults] stringForKey:kUserDefault_generateTorrents_lastTargetFolder];
	
	if (savePath 
		&& [[NSFileManager defaultManager] fileExistsAtPath:savePath isDirectory:&isDir]  
		&& isDir)
	{
		if ([[self _filePaths] count] > 0)
		{
			//what kind are we, tracker or trackerless?
			if ([self generatesTrackerlessTorrents])
			{
				//are we auto?
				if ([self trackerlessTorrentsUseSpecificNodes])
				{
					result = [[self DHTNodesAsString] length] > 0;
				}
				else
					result = YES;	//auto needs no validation... at least none I'll do.
			}
			else
			{
				//if we have anything that seems like a URL, let's go.
				if ([(NSString*)[self _announceURL] length] > 0)
					result = YES;	//that seems like a URL.
			}
		}
	}
	
	return result;
}

- (void)startGeneration:sender
{
	[[self window] endEditingFor:nil];
	
	if ([self isReadyToGenerateTorrents])
	{
		id		agent;
		
		agent = [self _agent];
		
		[agent setGenerateAnnounceURL:[self _announceURL]];
		[agent setGenerateDestDirPath:[[NSUserDefaults standardUserDefaults] stringForKey:kUserDefault_generateTorrents_lastTargetFolder]];
		[agent setGeneratePieceSize:[self _pieceSize]];
		[agent setGenerateFiles:[self _filePaths] withAttributes:_attribs];
		
		//ok... that's the old code. insert stuff to support trackerless here.
		if ([self trackerlessTorrentsUseSpecificNodes])
			[agent setGenerateDHTNodesString:[self DHTNodesAsString]];
		else
			[agent setGenerateDHTNodesString:@""];
		[agent setGenerateTrackerless:[self generatesTrackerlessTorrents]];
		
		//save the trackerless nodes if we're doing that
		if ([self generatesTrackerlessTorrents] && [self trackerlessTorrentsUseSpecificNodes])
			[[NSUserDefaults standardUserDefaults] setObject: [self DHTNodesAsString]
													  forKey: kUserDefault_generateTorrents_trackerlessNodes];

		[agent stopGenerate:nil];	
		[agent startGenerate:self];	//whenever I do a start I have to follow up with a stop, or else
									//it won't let me start again (already starting). so I just always
									//send a stop before starting.
		
		[self _startTrackingAgent];		
	}
	else
		NSBeep();	//I should probably tell them something.
}

- (IBAction)startGeneration_old:(id)sender
{
	[[self window] endEditingFor:nil];

	if ([[self _filePaths] count] > 0 && [(NSString*)[self _announceURL] length] > 0)
	{
		//ask for a directory, and then we'll start this sucker.
		id		openPanel =  [NSOpenPanel openPanel];
		id		directory;
		[openPanel setCanChooseDirectories:YES];
		[openPanel setCanChooseFiles:NO];
		
		[openPanel setTitle:SKLocalizedString(
			@"Choose a Folder To Save the Generated Torrents", 
			@"torrent generation choose target directory title")];
		[openPanel setPrompt:SKLocalizedString(
			@"Choose", 
			@"torrent generation choose target directory prompt")];
		
		[self _agent];	//warm up the agent while the user is choosing
		
		directory = [[NSUserDefaults standardUserDefaults] 
						stringForKey:kUserDefault_generateTorrents_lastTargetFolder];
		
		[openPanel beginSheetForDirectory:directory
								 file:nil
								types:nil
					   modalForWindow:[self window]
					    modalDelegate:self 
					   didEndSelector:@selector(_userChoseTargetDirectory:returnCode:contextInfo:) 
						  contextInfo:nil];
	}
	else
		NSBeep();	//the gui doesn't currently let this happen
}

- (void) reloadData
{
	switch (_state)
	{
		case kGenerateTorrentsState_setup:
			[_tableView reloadData];
		break;
		
		case kGenerateTorrentsState_generating:
			[self _updateGenerateStats];
		break;
		
		case kGenerateTorrentsState_done:
			[self _showCompletionStats];
		break;
		
		case kGenerateTorrentsState_fault:
			[self _showFaultResponse];
		break;
	}
}

- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem;
{
	[self _updateGenerateButton];
}
@end

@implementation GenerateTorrentsController (Private)

- _announceURL;
{
	return [_urlText stringValue];
}

- (int) _pieceSize;
{
	return [_pieceSizeText intValue];
}

- _filePaths;
{
	return _files;
}

- _agent
{
	if (_agent == nil)
		_agent = [TomatoTorrentAgent new];
	
	return _agent;
}

- (void) _appWillTerminate:notif
{
	id		defaults;
	
	if (_agent)
	{
		[_agent shutdown];
		[_agent release];
		_agent = nil;
	}
	
	defaults = [NSUserDefaults standardUserDefaults];
	[defaults setBool: [[[__trackerTypeTabView selectedTabViewItem] identifier] isEqual:kTabIdentifier_trackerless]
			   forKey: kUserDefault_generateTorrents_isTrackerless];
	[defaults setBool: ([[__trackerlessTypeRadioMatrix selectedCell] tag] == kTrackerlessAutoNodesTag)
			   forKey: kUserDefault_generateTorrents_useTrackerlessAuto];
}

- _addFiles:files afterRow:(int)row
{
	id		ite = [files objectEnumerator];
	id		object;
	
	while (object = [ite nextObject])
	{
		if ([_files containsObject:object] == NO)

		if (row < 0)
			[_files addObject:object],
			[_attribs addObject:[NSMutableDictionary dictionary]];
			
		else
			[_files insertObject:object atIndex:row],
			[_attribs insertObject:[NSMutableDictionary dictionary] atIndex:row];
	}
	[self _updateGenerateButton];
	[_tableView reloadData];
	
	return self;
}

- (void) _userChoseSourceItemsFrom:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
{
	if (returnCode == NSOKButton)
	{
		[self _addFiles:[sheet filenames] afterRow:-1];
		
		[[NSUserDefaults standardUserDefaults] setObject:[sheet directory]
												  forKey:kUserDefault_generateTorrents_lastSourceFolder];
	}
}

- (void) _userChoseTargetDirectory:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
{
	id		agent;

	if (returnCode == NSOKButton)
	{
		[[NSUserDefaults standardUserDefaults] setObject:[sheet directory]
												  forKey:kUserDefault_generateTorrents_lastTargetFolder];
												  
		//let's start a generation session
		agent = [self _agent];
		
		[agent setGenerateAnnounceURL:[self _announceURL]];
		[agent setGenerateDestDirPath:[sheet directory]];
		[agent setGeneratePieceSize:[self _pieceSize]];
		[agent setGenerateFiles:[self _filePaths] withAttributes:_attribs];
		
		[sheet orderOut:nil];
		
		[agent stopGenerate:nil];	
		[agent startGenerate:self];	//whenever I do a start I have to follow up with a stop, or else
									//it won't let me start again (already starting). so I just always
									//send a stop before starting.
		
		[self _startTrackingAgent];
	}
}

- (void) __userChoseTargetDirectory:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
{
	if (returnCode == NSOKButton)
	{
		//save prefs and update the user interface.
		[[NSUserDefaults standardUserDefaults] setObject:[sheet directory]
												  forKey:kUserDefault_generateTorrents_lastTargetFolder];
		[__destinationFolderText setStringValue:[[NSFileManager defaultManager] displayPathForPath:[sheet directory]]];
	}
}

- (BOOL)windowShouldClose:(id)sender;
{
	return _state != kGenerateTorrentsState_generating;	//+++ put up a sheet asking if they want to cancel.
}

- (int)numberOfRowsInTableView:(NSTableView *)tableView;
{
	return [_files count];
}

- (id)tableView:(NSTableView *)tableView objectValueForTableColumn:(NSTableColumn *)tableColumn row:(int)row;
{
	id	result;
	
	if ([[tableColumn identifier] isEqual:@"item"])
		result = [[NSFileManager defaultManager] displayPathForPath:[_files objectAtIndex:row]];
	else
		result = [[_attribs objectAtIndex:row] objectForKey:kTomatoAgentKey_generate_fileAttrib_comment];
	
	return result;
}

- (void)tableView:(NSTableView *)tableView setObjectValue:(id)object forTableColumn:(NSTableColumn *)tableColumn row:(int)row;
{
	if ([[tableColumn identifier] isEqual:@"comment"])
	{
		id	attrib = [_attribs objectAtIndex:row];
		
		if (object)
			[attrib setObject:object forKey:kTomatoAgentKey_generate_fileAttrib_comment];
		else
			[attrib removeObjectForKey:kTomatoAgentKey_generate_fileAttrib_comment];
	}
}

- (void)tableViewSelectionDidChange:(NSNotification *)notification;
{
	[_removeButton setEnabled:[_tableView numberOfSelectedRows] > 0];
}


- (NSDragOperation)tableView:(NSTableView*)tv validateDrop:(id <NSDraggingInfo>)info proposedRow:(int)row proposedDropOperation:(NSTableViewDropOperation)op;
{
	return NSDragOperationGeneric;
}

- (BOOL)tableView:(NSTableView*)tv acceptDrop:(id <NSDraggingInfo>)info row:(int)row dropOperation:(NSTableViewDropOperation)op;
{
	id		pasteboard = [info draggingPasteboard];
	id		files;
	BOOL	result = NO;

	if (files = [pasteboard propertyListForType:NSFilenamesPboardType])
		[self _addFiles:files afterRow:row],
		result = YES;
		
	return result;
}


- (void)controlTextDidChange:(NSNotification *)notif
{
	[self _updateGenerateButton];
}

- (void)controlTextDidEndEditing:(NSNotification *)notif
{
	if ([notif object] == _urlText && [[_urlText stringValue] length] > 0)
	{
		[[NSUserDefaults standardUserDefaults] setObject:[_urlText stringValue]
												  forKey:kLastTrackerURL];

		//history
		[__trackerHistory removeObject:[_urlText stringValue]];
		[__trackerHistory insertObject:[_urlText stringValue] atIndex:0];
		if ([__trackerHistory count] > 7)
			[__trackerHistory removeObjectsInRange:NSMakeRange(7, [__trackerHistory count] - 7)];

		[[NSUserDefaults standardUserDefaults] setObject:__trackerHistory
												  forKey:kUserDefault_generateTorrents_trackerHistory];
		
		[_urlText reloadData];
	}
}

- (int)numberOfItemsInComboBox:(NSComboBox *)aComboBox;
{
	return [__trackerHistory count];
}

- (id)comboBox:(NSComboBox *)aComboBox objectValueForItemAtIndex:(int)index;
{
	return [__trackerHistory objectAtIndex:index];
}

- (unsigned int)comboBox:(NSComboBox *)aComboBox indexOfItemWithStringValue:(NSString *)string;
{
	return [__trackerHistory indexOfObject:string];
}

- _updateGenerateButton
{
	[_generateButton setEnabled:[self isReadyToGenerateTorrents]];
	return self;
}

- _setState:(int)state;
{
	id		view = nil, string;
	id		lastView = [[self window] contentView];
	BOOL	blah = [[self window] isVisible];
	NSRect	frame;
	NSSize	max, min;
	
	[self window];	//load.
	
	max = min = NSZeroSize;
	_state = state;

	switch (state)
	{
		case kGenerateTorrentsState_setup:
			view = _setupView;
			frame = [view frame];
			max = min = frame.size;
			max.height = 0;
			
			[_files removeAllObjects];
			[_attribs removeAllObjects];
			[_tableView reloadData];
			
			string = [[NSUserDefaults standardUserDefaults] stringForKey:kLastTrackerURL];
			if (string == nil) string = @"";
			[_urlText setStringValue:string];
			[self _updateGenerateButton];
			[self tableViewSelectionDidChange:nil];
			
			[self _setLastResponse:nil];
		break;
		
		case kGenerateTorrentsState_generating:
			//wipe out the files
			[_files removeAllObjects];
			[_attribs removeAllObjects];
		
			[_cancelButton setTitle:SKLocalizedString(@"Cancel", nil)];
			[_cancelButton setAction:@selector(cancelGeneration:)];
			
			[_numItemsDisplay setStringValue:@""];
			[_bytesProcessedDisplay setStringValue:@""];
			[_currentFileText setStringValue:@""];
			[_progressTabView selectTabViewItemWithIdentifier:kTabIdentifier_progress];
			view = _generationView;

			frame = [view frame];
			max = min = frame.size;

			if ([_progressBar respondsToSelector:@selector(setDisplayedWhenStopped:)])
				[_progressBar setDisplayedWhenStopped:YES];
			
			[self reloadData];
		break;
		
		case kGenerateTorrentsState_fault:
			[_progressTabView selectTabViewItemWithIdentifier:kTabIdentifier_fault];

		//no break

		case kGenerateTorrentsState_done:
			[_cancelButton setTitle:SKLocalizedString(@"OK", nil)];
			[_cancelButton setAction:@selector(showGenerationSetup:)];
			view = _generationView;

			frame = [view frame];
			max = min = frame.size;
			
			[self reloadData];
		break;
	}
	
	if (lastView != view)
	{
		[[self window] switchContentViewTo:view showingViewDuringResize:_emptyView
			display:blah animate:blah];
	}
	
	[[self window] setMinimumContentSize:min maximumSize:max];
	
	
	return self;
}

- _startTrackingAgent
{
	if (_timer)
		[_timer invalidate];
	
	_timer = [NSTimer scheduledTimerWithTimeInterval:1 
												target:self 
											selector:@selector(_agentTrackingTimer:) 
											userInfo:nil 
											 repeats:YES];

	[_progressBar startAnimation:nil];
	[self _setState:kGenerateTorrentsState_generating];
	
	return self;
}

- _stopTrackingAgent:(int)state
{
	[_timer invalidate]; 
	_timer = nil;
	
	if (_state == kGenerateTorrentsState_generating)
		//queued transaction will cause this thing to be called multiple times,
		//and later 'reloadData's will wipe out the failure. We only need to
		//move from generating to an end state once.
	{
		[_progressBar stopAnimation:nil];
	
		[self _setState:state];
		[self reloadData];
	}
	
	return self;
}

- (void) _agentTrackingTimer:timer
{
	if ([[self _agent] generateState:self] == nil)
		[_progressBar setIndeterminate:YES];

	else if ([_progressBar isIndeterminate])
		[self reloadData];	//[_progressBar setIndeterminate:NO];	 it can decide if it should be indeterminate or not.
}

- _updateGenerateStats;
{
	void limbo()
	{
		[_numItemsDisplay setStringValue:SKLocalizedString(@"Starting...", @"generate starting title")];
		[_bytesProcessedDisplay setStringValue:@""];
		[_progressBar setIndeterminate:YES];
	}
	
	if (_lastResponse)
	{
		int			numFiles = [_files count];
		int			index;
		unsigned	totalBytes = 1;
		unsigned	completedBytes = 0;
		id			currentFile = @"";
		id			status;
		id			display;
		id			state = [_lastResponse responseContent];
		
		status = [state objectForKey:kTomatoAgentKey_generateState_status];
		
		if ([status isEqual:kTomatoAgentKey_generateState_status_finished])
		{
			[self _stopTrackingAgent:kGenerateTorrentsState_done];
		}
		else if ([status isEqual:kTomatoAgentKey_generateState_status_running])
		{
			if (currentFile = [state objectForKey:kTomatoAgentKey_generateState_currentItemPath])
			{
				//all stats are available.
				numFiles = [[state objectForKey:kTomatoAgentKey_generateState_numFiles] intValue];
				index = [[state objectForKey:kTomatoAgentKey_generateState_currentItemNum] intValue];
				totalBytes = [[state objectForKey:kTomatoAgentKey_generateState_totalBytes] unsignedIntValue];
				completedBytes = [[state objectForKey:kTomatoAgentKey_generateState_completedBytes] unsignedIntValue];
				
				display = SKLocalizedString(@"Processing Item %d of %d", @"(current#) of (total#) generate status");
				display = [NSString stringWithFormat:display, index, numFiles];
				[_numItemsDisplay setStringValue:display];

				display = SKLocalizedString(@"%@ of %@", @"(completed bytes) of (total bytes) generate status");
				display = [NSString stringWithFormat:display, 
										bt_format_file_size_object([state objectForKey:kTomatoAgentKey_generateState_completedBytes]),
										bt_format_file_size_object([state objectForKey:kTomatoAgentKey_generateState_totalBytes])];
				[_bytesProcessedDisplay setStringValue:display];
				
				display = SKLocalizedString(@"%@", @"(current#) of (total#): (item name) - generate name display");
				display = [NSString stringWithFormat:display, [currentFile stringByAbbreviatingWithTildeInPath]];
				
				[_currentFileText setStringValue:display];
				
				[_progressBar setMinValue:0];
				[_progressBar setMaxValue:totalBytes];
				[_progressBar setDoubleValue:completedBytes];
				
				[_progressBar setIndeterminate:NO];
			}
			else	//still limbo. clear stuff.
				limbo();
		}
		else
			limbo();	//this case actually doesn't happen. if we got status it's not set to limbo.
	}
	else
		limbo();
	
	return self;
}

- _showCompletionStats;
{
	[_numItemsDisplay setStringValue:SKLocalizedString(@"Finished!", @"generate done title")];
	[_currentFileText setStringValue:@""];
	[_bytesProcessedDisplay setStringValue:@""];	//may not have latest stats.
	
	[_progressBar setIndeterminate:NO];
	[_progressBar setMaxValue:1];
	[_progressBar setDoubleValue:1];
	
	if (_lastResponse)
	{
		id		errors = [[[_lastResponse responseContent] objectForKey:kTomatoAgentKey_generateState_errors] objectEnumerator];
		id		error;
		BOOL	gotem = NO;
		
		while (error = [errors nextObject])
		{
			NSLog(@"error during torrent generation:\n%@", error);
			gotem = YES;
		}
		
		//this is really lazy.
		if (gotem)
			[_currentFileText setStringValue:SKLocalizedString(
				@"Cryptic errors logged to /Applications/Utilies/Console!", 
				@"generate done with errors title (actually file name - sarwat's lazy)")];
	}
	
	return self;
}

- _showFaultResponse;
{
	id		formatter;

	[_faultTitle setStringValue:SKLocalizedString(@"Not Running Due To Fault:", @"post response fault title")];
	
	formatter = [[TorrentFaultFormatter new] autorelease];

	[_faultDisplay setObjectValue:[_lastResponse fault]];
	[_faultDisplay setFormatter:formatter];
	
	return self;
}

- _displayResponseFault
{
	[self _stopTrackingAgent:kGenerateTorrentsState_fault];
	
	return self;
}

- _setLastResponse:response
{
	if (_state != kGenerateTorrentsState_fault)
	{
		[_lastResponse release];
		_lastResponse = [response retain];
	}
	//else keep the last fault.
	
	return self;
}

@end

@implementation GenerateTorrentsController (TomatoTorrentAgentDelegate)
- tomatoTorrentAgent:agent generateStartup:response;
{
	id	fault = [response fault];
	
	[self _setLastResponse:response];

	if (fault == nil)
		[self reloadData];

	else
		[self _displayResponseFault];
	
	return self;
}

- tomatoTorrentAgent:agent generateStopped:response;
{
	id	fault = [response fault];
	
	[self _setLastResponse:response];

	if (fault == nil)
	{
		[self _stopTrackingAgent:kGenerateTorrentsState_done];
		[self reloadData];
	}
	else
		[self _displayResponseFault];
	
	return self;
}

- tomatoTorrentAgent:agent generateState:response;
{
	id	fault = [response fault];
	
	[self _setLastResponse:response];

	if (fault == nil)
		[self reloadData];

	else
		[self _displayResponseFault];
	
	return self;
}

@end
