//==============================================================================
//		ModuleOptionsController.h					TomatoTorrent
//==============================================================================
//  Created by Sarwat Khan on Thu Jun 12 2003.
//  Copyright (c) 2003, Sarwat Khan. All rights reserved.
//  
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are
//  met:
//          
//      1. Redistributions of source code must retain the above copyright
//         notice, this list of conditions and the following disclaimer.
//          
//      2. Redistributions in binary form must reproduce the above
//         copyright notice, this list of conditions and the following disclaimer
//         in the documentation and/or other materials provided with the
//         distribution.
//          
//      3. Neither Sarwat Khans name nor the names of any contributors to
//         the Tomato Torrent Software may be used to endorse or promote
//         products derived from this software without specific prior written
//         permission.
//  
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
//  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
//  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
//  A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
//  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
//  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
//  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
//  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
//  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#import <Foundation/Foundation.h>

#define kViewTag_moduleOptionsTable				32
#define	kViewTag_moduleOptionsNameText			33
#define kViewTag_moduleOptionsDescText			34

#define kTableColumnIdent_name							@"name"
#define kTableColumnIdent_value							@"value"
#define kTableColumnIdent_desc							@"desc"	//not used anymore

@interface ModuleOptionsController : NSObject 
{
	id		_data;
	id		_defaults;
	SEL		_defaultsSelector;
	
	id		_optionsList;
	
	id		_intFormatter;
	id		_realFormatter;
	
	id				_window;		//_table's intended window. use wisely.
	IBOutlet id		_table;
	IBOutlet id		_optionNameText;
	IBOutlet id		_optionDescText;
	
}

	//can be called multiple times, only first time has effect. this is so defaults
	//aren't loaded until needed.
- setModuleOptions:(NSMutableDictionary*)options defaultsSelector:(SEL)defaultsSelector
	controllingTableForWindow:window;
	
- (void) reloadData;

- (IBAction) restoreModuleDefaults:sender;

//I hacked in support for making this logic external. I didn't want to rethink of how
//to incorporate this class for the Download Progress Configuration table, as that's
//just a hack itself. One that's functioning pretty well :)
- setModuleConfiguration:(NSDictionary*)options defaultsSelector:(SEL)defaultsSelector;
- formatterForKey:key;
- (BOOL)keyHasBoolValue:key;
@end
