/* PreferencesController */

#import <Cocoa/Cocoa.h>

extern NSString* const kTomatoAutoStopPrefsDidChangeNotification;

typedef enum {
	kAutoStopTorrentMethod_shareRatio,
	kAutoStopTorrentMethod_dataLimit,
	kAutoStopTorrentMethod_timeLimit,
} TomatoTorrentDownloadAutoStopMethod;

@interface PreferencesController : NSWindowController
{
    IBOutlet id __autoCloseCheckbox;
    IBOutlet id __autoCloseRadioMatrix;
    IBOutlet id __autoCloseTabView;
    IBOutlet id __maxUploadRateField;
    IBOutlet id __seedingMaxUploadRateCheckbox;
    IBOutlet id __seedingMaxUploadRateField;
}

+ sharedInstance;

+ (BOOL) doAutoStopTomatoTorrentDownloads;
+ (TomatoTorrentDownloadAutoStopMethod) tomatoDownloadAutoStopMethod;
+ (float) tomatoTorrentTargetDownloadShareRatio;
+ (unsigned) seedingUploadLimitAsMegabytes;
+ (NSTimeInterval) seedingAutoStopTimeInterval;
+ (BOOL) usesSecondaryUploadRateForCompletedTorrents;
+ (unsigned) secondaryUploadRateKBs;

+ (BOOL) doAutoStopTomatoTorrentDownloadsByShareRatio;

+ (void) postDefaultsChangedNotification;
+ (void) noteTorrentDownloadOptionsDefaultsChanged;

- (void) update;
@end
